unit hiDDEServer;

interface

uses Kol,Share,Debug,DDEML,Windows;

type
  THIDDEServer = class(TDdeConversation)
   private
    FError:boolean;
    FValue:string;
    FLastTopic:string;
    FLastItem:string;
    
    function MyCallback(uType,uFmt:cardinal; hConv,hSz1,hSz2,hData:THandle; dwData1,dwData2:DWORD):cardinal;

   public
    _prop_ServiceName:string;

    _data_ChangedTopic:THI_Event;
    _data_ChangedItem:THI_Event;

    _event_onConnect:THI_Event;
    _event_onGetItem:THI_Event;
    _event_onPutItem:THI_Event;
    _event_onExecute:THI_Event;

    constructor Create;
    destructor Destroy; override;

    procedure _work_doStart(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _work_doReturnItem(var _Data:TData; Index:word);
    procedure _work_doSendChanges(var _Data:TData; Index:word);
    procedure _work_doSetError(var _Data:TData; Index:word);

    procedure _var_TopicName(var _Data:TData; Index:word);
    procedure _var_ItemName(var _Data:TData; Index:word);

    procedure _work_doServiceName(var _Data:TData; Index:word);
  end;

implementation

constructor THIDDEServer.Create;
begin
  inherited;
  FConv := 0;
  FCallback := MyCallback;
end;

destructor THIDDEServer.Destroy;
begin
  inherited;
end;

function THIDDEServer.MyCallback(uType,uFmt:cardinal; hConv,hSz1,hSz2,hData:THandle; dwData1,dwData2:DWORD):cardinal;
var s:string; dwLen:DWORD;
begin
  Result := DDE_FNOTPROCESSED;
  case uType of
  XTYP_CONNECT:
   begin
     dwLen := DdeQueryString(g_DdeInstance,hSz1,nil,0,CP_WINANSI)+1; SetLength(FLastTopic,dwLen);
     DdeQueryString(g_DdeInstance,hSz1,@FLastTopic[1],dwLen,CP_WINANSI); SetLength(FLastTopic,dwLen-1);
     FError := False; _hi_onEvent(_event_onConnect, FLastTopic);
     if not FError then Result := DDE_FACK;
   end;
  XTYP_CONNECT_CONFIRM:
   begin
     Result := DDE_FACK;
   end;
  XTYP_EXECUTE:
   begin
     dwLen := DdeQueryString(g_DdeInstance,hSz1,nil,0,CP_WINANSI)+1; SetLength(FLastTopic,dwLen);
     DdeQueryString(g_DdeInstance,hSz1,@FLastTopic[1],dwLen,CP_WINANSI); SetLength(FLastTopic,dwLen-1);
     dwLen := DdeGetData(hData,nil,0,0); SetLength(s,dwLen);
     DdeGetData(hData,@s[1],dwLen,0);
     FError := False; _hi_onEvent(_event_onExecute, s);
     if not FError then Result := DDE_FACK;
   end;
  XTYP_ADVREQ,XTYP_REQUEST:
   begin
     dwLen := DdeQueryString(g_DdeInstance,hSz1,nil,0,CP_WINANSI)+1; SetLength(FLastTopic,dwLen);
     DdeQueryString(g_DdeInstance,hSz1,@FLastTopic[1],dwLen,CP_WINANSI); SetLength(FLastTopic,dwLen-1);
     dwLen := DdeQueryString(g_DdeInstance,hSz2,nil,0,CP_WINANSI)+1; SetLength(FLastItem,dwLen);
     DdeQueryString(g_DdeInstance,hSz2,@FLastItem[1],dwLen,CP_WINANSI); SetLength(FLastItem,dwLen-1);
     FError := False; _hi_onEvent(_event_onGetItem,FLastItem);
     if not FError then Result := DdeCreateDataHandle(g_DdeInstance,PChar(FValue),Length(FValue)+1,0,hSz2,CF_TEXT,0);
   end;
  XTYP_POKE:
   begin
     dwLen := DdeQueryString(g_DdeInstance,hSz1,nil,0,CP_WINANSI)+1; SetLength(FLastTopic,dwLen);
     DdeQueryString(g_DdeInstance,hSz1,@FLastTopic[1],dwLen,CP_WINANSI); SetLength(FLastTopic,dwLen-1);
     dwLen := DdeQueryString(g_DdeInstance,hSz2,nil,0,CP_WINANSI)+1; SetLength(FLastItem,dwLen);
     DdeQueryString(g_DdeInstance,hSz2,@FLastItem[1],dwLen,CP_WINANSI); SetLength(FLastItem,dwLen-1);
     dwLen := DdeGetData(hData,nil,0,0); SetLength(s,dwLen);
     DdeGetData(hData,@s[1],dwLen,0);
     FError := False; _hi_onEvent(_event_onPutItem,s);
     if not FError then Result := DDE_FACK;
   end;
  XTYP_ADVSTART:
   begin
     dwLen := DdeQueryString(g_DdeInstance,hSz1,nil,0,CP_WINANSI)+1; SetLength(FLastTopic,dwLen);
     DdeQueryString(g_DdeInstance,hSz1,@FLastTopic[1],dwLen,CP_WINANSI); SetLength(FLastTopic,dwLen-1);
     dwLen := DdeQueryString(g_DdeInstance,hSz2,nil,0,CP_WINANSI)+1; SetLength(FLastItem,dwLen);
     DdeQueryString(g_DdeInstance,hSz2,@FLastItem[1],dwLen,CP_WINANSI); SetLength(FLastItem,dwLen-1);
     FError := False; _hi_onEvent(_event_onGetItem,FLastItem);
     if not FError then Result := DDE_FACK;
   end;
  XTYP_ADVSTOP:
   begin
     Result := DDE_FACK;
   end;
  end;
end; 

procedure THIDDEServer._work_doStart;
var hszService:THandle;
begin
  hszService := DdeCreateStringHandle(g_DdeInstance,PChar(_prop_ServiceName),CP_WINANSI); 
  DdeNameService(g_DdeInstance,hszService,0,DNS_REGISTER+DNS_FILTERON);
  DdeFreeStringHandle(g_DdeInstance,hszService);
end;

procedure THIDDEServer._work_doStop;
var hszService:THandle;
begin
  hszService := DdeCreateStringHandle(g_DdeInstance,PChar(_prop_ServiceName),CP_WINANSI); 
  DdeNameService(g_DdeInstance,hszService,0,DNS_UNREGISTER);
  DdeFreeStringHandle(g_DdeInstance,hszService);
end;

procedure THIDDEServer._work_doReturnItem;
begin
  FValue := ToString(_Data);
end;

procedure THIDDEServer._work_doSendChanges;
var hszTopic,hszItem:THandle; s:string;
begin
  s := ReadString(_Data,_data_ChangedTopic,'');
  if s='' then hszTopic := 0 else
    hszTopic := DdeCreateStringHandle(g_DdeInstance,PChar(s),CP_WINANSI); 
  s := ReadString(_Data,_data_ChangedItem,'');
  if s='' then hszItem := 0 else
    hszItem := DdeCreateStringHandle(g_DdeInstance,PChar(s),CP_WINANSI); 
  DdePostAdvise(g_DdeInstance,hszTopic,hszItem);
  if hszItem<>0 then DdeFreeStringHandle(g_DdeInstance,hszItem);
  if hszTopic<>0 then DdeFreeStringHandle(g_DdeInstance,hszTopic);
end;

procedure THIDDEServer._work_doSetError;
begin
  FError := True;
end;

procedure THIDDEServer._var_TopicName;
begin
  dtString(_Data, FLastTopic);
end;

procedure THIDDEServer._var_ItemName;
begin
  dtString(_Data, FLastItem);
end;

procedure THIDDEServer._work_doServiceName;
begin
  _prop_ServiceName := ToString(_Data);
end;

end.
